package com.asgteach.bpmonitor;

import com.asgteach.bpmonitor.views.EditView;
import com.asgteach.bpmonitor.views.ReadingsView;
import com.asgteach.bpmonitor.views.GraphView;
import com.asgteach.bpmonitor.views.StatView;
import com.gluonhq.charm.glisten.application.MobileApplication;
import com.gluonhq.charm.glisten.visual.Swatch;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.stage.Stage;
import com.gluonhq.charm.glisten.mvc.View;

public class BPMonitor extends MobileApplication {

    public static final String PRIMARY_VIEW = HOME_VIEW;
    public static final String GRAPH_VIEW = "Graph View";
    public static final String STAT_VIEW = "Stat View";
    public static final String EDIT_VIEW = "Edit View";
    
    @Override
    public void init() {
        addViewFactory(PRIMARY_VIEW, () -> (View) new ReadingsView().getView());
        addViewFactory(GRAPH_VIEW, () -> (View) new GraphView().getView());
        addViewFactory(STAT_VIEW, () -> (View) new StatView().getView());
        addViewFactory(EDIT_VIEW, () -> (View) new EditView().getView());       
    }

    @Override
    public void postInit(Scene scene) {
        Swatch.BLUE.assignTo(scene);

        scene.getStylesheets().add(BPMonitor.class.getResource("style.css").toExternalForm());
        ((Stage) scene.getWindow()).getIcons().add(new Image(BPMonitor.class.getResourceAsStream("/icon.png")));
    }
}
