package com.asgteach.capitalpunishment;

import com.asgteach.capitalpunishment.model.Country;
import com.asgteach.capitalpunishment.views.QuizView;
import com.asgteach.capitalpunishment.views.MapView;
import com.gluonhq.charm.glisten.application.MobileApplication;
import com.gluonhq.charm.glisten.visual.Swatch;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.stage.Stage;

public class CapitalPunishment extends MobileApplication {

    public static final String PRIMARY_VIEW = HOME_VIEW;
    public static final String SECONDARY_VIEW = "Map View";
    public static final String MENU_LAYER = "Side Menu";
    public static Country mapCenter;
    
    @Override
    public void init() {
        addViewFactory(PRIMARY_VIEW, 
                () -> new QuizView(PRIMARY_VIEW).getView());
        addViewFactory(SECONDARY_VIEW, 
                () -> new MapView(SECONDARY_VIEW).getView());
    }

    @Override
    public void postInit(Scene scene) {
        Swatch.BLUE.assignTo(scene);

        scene.getStylesheets().add(
                CapitalPunishment.class.getResource("style.css")
                        .toExternalForm());
        ((Stage)scene.getWindow()).getIcons().add(new Image(
                CapitalPunishment.class.getResourceAsStream("/icon.png")));
    }
}
